/* Open port, then Set LED display on/off.  

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

    File level history (record changes for this file here.)

    led.c   
    
    v 0.0.0  1 January 2009 by Cindy Huang
   
*/
   
#include <stdio.h>
#include <stdlib.h>
#include "msw.h"

int main(int argc, char **argv)
{
	int  wRetVal ;
	unsigned int addr,value;
  
	wRetVal = Open_Slot(0);
	
	if (wRetVal > 0) {
		printf("open Slot failed!\n");
		return (-1);
	}
	
	if (argc != 3) {
		printf("Function: led\n");
		printf("Description: Set LED ON/OFF \n");
		printf("Usage: led.exe addr value\n");
		printf("Range: addr 1~4 for LP-51xx, addr 5 only for LP-8x3x/8x4x \n");
		printf("       value: 1->ON ; 0->OFF \n");
		printf("Example: led.exe 4 1 \n");
		printf("Set LED4 ON\n");
		return FAILURE;
	}
	
  addr=	atoi(argv[1]);
  value=atoi(argv[2]);
  SetLED(addr,value);  
	//SetLED(atoi(argv[1]),atoi(argv[2]));  //1-->on ; 0-->off

  Close_Slot(0);
	return 0;
}
