/* Example of XW107 OR XW107i for LinPAC.

   Author: Moki Matsushima

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   v 0.0.0  1 Sep 2014 by Cindy Huang
     create, blah blah... */
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include "msw.h"
#include "xwboard.h"
#include "xw111i.h"

int main()
{
   unsigned int  quit=0, type, ret, iStatus, iDOValue, iInChannel, iOutChannel; 
 
/* open device file  */
   if (Open_Slot(1)) 
   {
	   printf("open Slot 1 failed!\n");
	   return FAILURE;
	 }
	 
	 ret=XW111i_Init();  
   if (ret!=0){  //Initialize the X110
      printf("Cannot find XW111i!  ret=%d \n", ret ); 
      return FAILURE;  
	 } 
	 
	 while (quit!=1)
   {   
      printf("\n\r");
      printf("        Demo program for LP-5000 + XW111i        \n\r");
      printf("=================================================\n\r");
      printf(" Please choose one of the following :            \n\r");
      printf("        0.) Exit.                                 \n\r");  
      printf("        1.) Write All DO channels.               \n\r");
      printf("        2.) Write One DO channel.                \n\r"); 
      printf("        3.) DO Readback All channels.            \n\r");
      printf("        4.) DO Readback One channel.             \n\r");
      printf(" Note:DO(Ch0~Ch15)                               \n\r");
      printf("=================================================\n\r");
      printf("Choose an option and press [Enter]:");
      scanf("%d",&type);
   
      switch (type)
      {
        case 0:     //exit               
            quit=1;       
            break;  
        
        case 1:     //Write all DO channels                
            printf("Please input Output value(0x0000~0xffff): ");
            scanf("%x:",&iDOValue);
        
            if ((iDOValue<0)||(iDOValue>65536))
            {
              printf("Out of range!");
              return FAILURE; 
            }
       
            XW111i_Write_All_DO(iDOValue);
            printf("Output value=> 0x%02x\r\n\n", iDOValue);
                          
            break;  
        
        case 2:     //Write single DO channel                
            printf("Please select output channel(0~15): ");
            scanf("%d:",&iOutChannel);
            printf("Please input channel status(0:OFF, 1:ON): ");
            scanf("%d:",&iStatus);
        
            if ((iOutChannel<0)||(iOutChannel>15)||(iStatus<0)||(iStatus>1))
            {
              printf("Out of range!\n");
              return FAILURE; 
            }
              
            XW111i_Write_One_DO(iOutChannel, iStatus);                      
				    printf("Channel %d ==> %s\r\n\n", iOutChannel, (iStatus>=1)?"ON":"OFF");
				            
            break;
            
        case 3:     //Read all DO ReadBack
            iDOValue=XW111i_Read_All_DO();      
            printf("Digital Output ReadBack=> 0x%02x\r\n", iDOValue);
            break;
        
        case 4:   //Read single DO ReadBack
            printf("Please select outport channel(0~15): ");
            scanf("%d", &iOutChannel);
                                
            if((iOutChannel<0)||(iOutChannel>15))
            {
              printf("Out of range!\n\n");
              break;
            } 
                
            ret=XW111i_Read_One_DO(iOutChannel);                                         
            if(ret)
              printf("Channel %d ==> ON\n\n", iOutChannel);
            else
              printf("Channel %d ==> OFF\n\n", iOutChannel);
      
            break;
        }
   
  }
           
	Close_Slot(1);
	return 0;
}
