/* demo for xw-boards (RS-485/422).

   Author: Moki Matsushima

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
     
/* Note:
   setting 'stty -F /dev/ttyS2 ispeed 9600 ospeed 9600' for COM4
   setting 'stty -F /dev/ttyS3 ispeed 9600 ospeed 9600' for COM5
   setting 'stty -F /dev/ttyS4 ispeed 9600 ospeed 9600' for COM6
   setting 'stty -F /dev/ttyS5 ispeed 9600 ospeed 9600' for COM7
*/

#include "msw.h"

#define COM_M1 "/dev/ttyS2"  /* COM4 */ 
#define COM_S1 "/dev/ttyS3"  /* COM5 */ 
#define COM_M2 "/dev/ttyS4"  /* COM6 */ 
#define COM_S2 "/dev/ttyS5"  /* COM7 */ 
#define COM_M3 "/dev/ttyS6"  /* COM8 */ 
#define COM_S3 "/dev/ttyS7"  /* COM9 */ 
#define COM_M4 "/dev/ttyS8"  /* COM10 */ 
#define COM_S4 "/dev/ttyS9"  /* COM11 */ 
#define RCVBUF_SIZE 128

int main()
{
  char fd[10];
	int i,r;			                  /* file descriptor */
	char *cmd1 ,*cmd2,*cmd3,*cmd4 ;	/* point to command string */
	char rbuf[RCVBUF_SIZE];			   	/* receive buffer */
	__tod_t texp;				           	/* to receive the expended time */
	

  fd[0] = sio_open(COM_M1, B9600, DATA_BITS_8, NO_PARITY,ONE_STOP_BIT);
	fd[2] = sio_open(COM_M2, B9600, DATA_BITS_8, NO_PARITY,ONE_STOP_BIT);
	if (fd[0] == ERR_PORT_OPEN) {
		printf("open port_m failed!\n");
		return (-1);
	}
	if (fd[2] == ERR_PORT_OPEN) {
		printf("open port_m failed!\n");
		return (-1);
	}
	fd[1] = sio_open(COM_S1, B9600, DATA_BITS_8, NO_PARITY,ONE_STOP_BIT);
	fd[3] = sio_open(COM_S2, B9600, DATA_BITS_8, NO_PARITY,ONE_STOP_BIT);
	if (fd[1] == ERR_PORT_OPEN) {
		printf("open port_s failed!\n");
		return (-1);
	}
  if (fd[3] == ERR_PORT_OPEN) {
		printf("open port_s failed!\n");
		return (-1);
	}
	
	
	fd[4] = sio_open(COM_M3, B9600, DATA_BITS_8, NO_PARITY,ONE_STOP_BIT);
	fd[6] = sio_open(COM_M4, B9600, DATA_BITS_8, NO_PARITY,ONE_STOP_BIT);
	if (fd[0] == ERR_PORT_OPEN) {
		printf("open port_m failed!\n");
		return (-1);
	}
	if (fd[2] == ERR_PORT_OPEN) {
		printf("open port_m failed!\n");
		return (-1);
	}
	fd[5] = sio_open(COM_S3, B9600, DATA_BITS_8, NO_PARITY,ONE_STOP_BIT);
	fd[7] = sio_open(COM_S4, B9600, DATA_BITS_8, NO_PARITY,ONE_STOP_BIT);
/**/if (fd[1] == ERR_PORT_OPEN) {
		printf("open port_s failed!\n");
		return (-1);
	}
  if (fd[3] == ERR_PORT_OPEN) {
		printf("open port_s failed!\n");
		return (-1);
	}
	
  //printf("fd[0]=%d\n", fd[0]);
  //printf("fd[1]=%d\n", fd[1]);
  //printf("fd[2]=%d\n", fd[2]);
  //printf("fd[3]=%d\n", fd[3]);
  //printf("fd[4]=%d\n", fd[4]);
  //printf("fd[5]=%d\n", fd[5]);
  //printf("fd[6]=%d\n", fd[6]);
  //printf("fd[7]=%d\n", fd[7]);
  cmd1 = "send1";
  cmd2 = "send2";
  cmd3 = "send3";
  cmd4 = "send4";
	sio_set_noncan(fd[0]);
	sio_set_noncan(fd[1]);
	sio_set_noncan(fd[2]);
	sio_set_noncan(fd[3]);
	sio_set_noncan(fd[4]);
	sio_set_noncan(fd[5]);
	sio_set_noncan(fd[6]);
	sio_set_noncan(fd[7]);

/**********************************************************************
 *  sio_set_timer
 *
 *  set input condictions for given port, this function for
 *  non-canonical mode only
 *
 *  Arguments: 
 *    fd       file descriptor for the port
 *    vmin     minmum number of bytes to read
 *    vtime    interbyte timer
 *             the number of tenths-of-a-second to wait for data to arrive
 *             
 *  Returned:  void
 */
	sio_set_timer(fd[0], 0, 0);         	/* set timeout for 0 sec */
	sio_set_timer(fd[1], 0, 0);	          /* set timeout for 0 sec */
	sio_set_timer(fd[2], 0, 0);         	/* set timeout for 0 sec */
	sio_set_timer(fd[3], 0, 0);	          /* set timeout for 0 sec */
	//sio_set_timer(fd[4], 0, 0);         	/* set timeout for 0 sec */
	//sio_set_timer(fd[5], 0, 0);	          /* set timeout for 0 sec */
	//sio_set_timer(fd[6], 0, 0);         	/* set timeout for 0 sec */
	//sio_set_timer(fd[7], 0, 0);	          /* set timeout for 0 sec */
	
	
  if (write(fd[0], cmd1, strlen(cmd1)) == -1) {
		printf("Write COM4 error!\n");
		return (-1);
	}
	
  if (write(fd[2], cmd2, strlen(cmd2)) == -1) {
		printf("Write COM6 error!\n");
		return (-1);
	}
	
	if (write(fd[4], cmd3, strlen(cmd3)) == -1) {
		printf("Write COM8 error!\n");
		return (-1);
	}
 
  if (write(fd[6], cmd4, strlen(cmd4)) == -1) {
		printf("Write COM10 error!\n");
		return (-1);
	}
	
	  
  for(i=1;i<6;i++)                     //read one every time
  { 
    //Sleep(100);
    while(!(r=read(fd[1], &rbuf[i], sizeof(rbuf[i])))){}
    printf("read %d byte --> ",r);
    printf("%c\n",rbuf[i]);
  }
 	
  for(i=1;i<6;i++)                     //read one every time
  { 
    //Sleep(100);
    while(!(r=read(fd[3], &rbuf[i], sizeof(rbuf[i])))){}
    printf("read %d byte --> ",r);
    printf("%c\n",rbuf[i]); 
  }
  
  for(i=1;i<6;i++)                     //read one every time
  { 
    //Sleep(100);
    while(!(r=read(fd[5], &rbuf[i], sizeof(rbuf[i])))){}
    printf("read %d byte --> ",r);
    printf("%c\n",rbuf[i]);
    
  }
  for(i=1;i<6;i++)                     //read one every time
  { 
    //Sleep(100);
    while(!(r=read(fd[7], &rbuf[i], sizeof(rbuf[i])))){}
    printf("read %d byte --> ",r);
    printf("%c\n",rbuf[i]); 
  }

  printf("\n");
  
  sio_close(fd[0]);
  sio_close(fd[1]);
  sio_close(fd[2]);
  sio_close(fd[3]);
  sio_close(fd[4]);
  sio_close(fd[5]);
  sio_close(fd[6]);
  sio_close(fd[7]);
  return (0);
}
