
/********************************************************************/
/*  XW111i:                                                         */
/*          16 D/O channel                                          */
/********************************************************************/
/********************************************************************/
/*	[Caution]                                                       */
/*	The EEPROM block 7 on X board is used to store A/D calibration  */
/*	settings. When you use the EEPROM on X board, do not overwrite  */
/*  it.                                                             */
/********************************************************************/

#ifndef __XW111i_H
#define __XW111i_H

#ifdef __cplusplus
extern "C" {
#endif

#define XW111i_DigitalIn      XW111i_Read_All_DI
#define XW111i_DigitalOut     XW111i_Write_All_DO
//#define fAD_Gain    XW107_fAD_Gain
//#define fAD_Offset  XW107_fAD_Offset

//for LinPAC slot0~slot8
static int SlotAddr[9] ={0x1,0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8};

int XW111i_Init(void);
/* Initiate the XW111i library
     Return
        On success, returns zero
        On error, returns -1, XW111i cannot be found */

unsigned XW111i_GetLibVersion(void);
/*  Current version is 1.00 (return 0x0100) */


void XW111i_Write_All_DO(int iOutValue);
/*  iOutValue: 0x0 ~ 0xFF  */

void XW111i_Write_One_DO(int iChannel, int iStatus);
/*  iChannel = 0
    iStatus = 1 => Status is ON
    iStatus = 0 => Status is OFF    */

int XW111i_Read_All_DO(void);
/*  Return data =  0x00 ~ 0xff  */

int XW111i_Read_One_DO(int iChannel);
/*  iChannel = 0
    Return 1 => ON
    Return 0 => OFF */


#ifdef __cplusplus
}
#endif

#endif
